const memory = require('./src/memory');
const registerDefaults = require('./src/registerDefaults');

/**
 * @namespace
 * @property {TypeParser_Type} Boolean
 * @property {TypeParser_Type} String
 * @property {TypeParser_Type} Date
 * @property {TypeParser_Type} Function
 * @property {TypeParser_Type} Array
 * @property {TypeParser_Type} Number
 * @property {TypeParser_Type} Object
 * @property {TypeParser_Type} Empty
 * @property {TypeParser_Type} Timestamp
 * @property {TypeParser_Type} ValidDate
 *
 * @property {Function} register
 * @property {Function} list
 */
const T = { isTypeOf: {}, from: {} };

T.register = memory.register.bind(null, T);
T.list     = memory.list;

// Registering the default types
registerDefaults(T);

module.exports = T;