const conversion = {
    toArray:     require('./conversion/toArray'),
    toTimestamp: require('./conversion/toTimestamp'),
    toBoolean:   require('./conversion/toBoolean'),
    toDate:      require('./conversion/toDate'),
    toNumber:    require('./conversion/toNumber'),
    toObject:    require('./conversion/toObject'),
    toString:    require('./conversion/toString'),
    toFunction:  require('./conversion/toFunction'),
};

const validation = {
    isArray:     require('./validation/isArray'),
    isBoolean:   require('./validation/isBoolean'),
    isDate:      require('./validation/isDate'),
    isNumber:    require('./validation/isNumber'),
    isObject:    require('./validation/isObject'),
    isString:    require('./validation/isString'),
    isFunction:  require('./validation/isFunction'),
    isEmpty:     require('./validation/isEmpty'),
    isTimestamp: require('./validation/isTimestamp'),
    isValidDate: require('./validation/isValidDate'),
};

/**
 * Registers the default types in the TypeParser
 */
module.exports = function (T) {

    // Boolean
    T.register({
        title: 'Boolean',
        from: conversion.toBoolean,
        isTypeOf: validation.isBoolean,
    });

    // String
    T.register({
        title: 'String',
        from: conversion.toString,
        isTypeOf: validation.isString,
    });

    // Date
    T.register({
        title: 'Date',
        from: conversion.toDate,
        isTypeOf: validation.isDate,
    });

    // Function
    T.register({
        title: 'Function',
        from: conversion.toFunction,
        isTypeOf: validation.isFunction,
    });

    // Array
    T.register({
        title: 'Array',
        from: conversion.toArray,
        isTypeOf: validation.isArray,
    });

    // Number
    T.register({
        title: 'Number',
        from: conversion.toNumber,
        isTypeOf: validation.isNumber,
    });

    // Object
    T.register({
        title: 'Object',
        from: conversion.toObject,
        isTypeOf: validation.isObject,
    });

    // Empty
    T.register({
        title: 'Empty',
        isTypeOf: validation.isEmpty,
    });

    // Timestamp
    T.register({
        title: 'Timestamp',
        from: conversion.toTimestamp,
        isTypeOf: validation.isTimestamp,
    });

    // ValidDate
    T.register({
        title: 'ValidDate',
        isTypeOf: validation.isValidDate,
    });

};