const isEmpty = require('./isEmpty');
const toNumber= require('../conversion/toNumber');
const isValidDate = require('./isValidDate');

/**
 * Checks if the input is a valid timestamp
 * @param  {*} v
 * @return {Boolean}
 */
module.exports = function (v) {
    const c = toNumber(v, { mode: 'NaNtoUndefined' });
    if (isEmpty(c)) { return false; }
    return isValidDate(new Date(c));
};