const assert = require('assert');

const T = require('../index');

describe('Testing Conversion functions', () => {
    require('./suites/toArray')();
    require('./suites/toBoolean')();
    require('./suites/toDate')();
    require('./suites/toNumber')();
    require('./suites/toObject')();
    require('./suites/toString')();
    require('./suites/toFunction')();
    require('./suites/toTimestamp')();
});

describe('Testing Conversion from constructor', () => {
    require('./suites/toArray')((value, mode) => {
        return T.Array.from(value, mode);
    });
    require('./suites/toBoolean')((value, mode) => {
        return T.Boolean.from(value, mode);
    });
    require('./suites/toDate')((value, mode) => {
        return T.Date.from(value, mode);
    });
    require('./suites/toNumber')((value, mode) => {
        return T.Number.from(value, mode);
    });
    require('./suites/toObject')((value, mode) => {
        return T.Object.from(value, mode);
    });
    require('./suites/toString')((value, mode) => {
        return T.String.from(value, mode);
    });
    require('./suites/toFunction')((value, mode) => {
        return T.Function.from(value, mode);
    });
    require('./suites/toTimestamp')((value, mode) => {
        return T.Timestamp.from(value, mode);
    });
});
