const assert = require('assert');

const isValidTitle = require('../src/isValidTitle');

describe('Testing isValidTitle', () => {

    [
        { test: 'title',    expect: false },
        { test: "tItLe",    expect: false },
        { test: "1Titl",    expect: false },
        { test: "1",        expect: false },
        { test: 0,          expect: false },
        { test: 1,          expect: false },
        { test: [],         expect: false },
        { test: {},         expect: false },
        { test: new Date(), expect: false },
        { test: NaN,        expect: false },
        { test: undefined,  expect: false },
        { test: null,       expect: false },
        { test: true,       expect: false },
        { test: false,      expect: false },

        { test: "TITLE", expect: true },
        { test: "Title", expect: true },
        { test: "TiTlE", expect: true },
        { test: "T1234", expect: true },
        { test: "T",     expect: true },
    ].forEach(({ test, expect }) => {
        it(`${test} => ${expect}`, () => {
            assert.equal(isValidTitle(test), expect);
        });
    });

});
