const assert = require('assert');

const T = require('../../index');

module.exports = function () {
    describe('Testing register and list', () => {

        it('No title', (done) => {
            try {
                T.register({
                    isTypeOf: function () {},
                });
                T.register({
                    isTypeOf: function () {},
                    from: function () {},
                });
                T.register({
                    from: function () {},
                });
                T.register({
                });
                assert(false);
            }
            catch (e) {
                assert(true);
                done();
            }
        });

        it('No methods', (done) => {
            try {
                T.register({
                    title: 'Method 1'
                });
                assert(false);
            }
            catch (e) {
                assert(true);
                done();
            }
        });

        it('Title and To', (done) => {
            T.register({
                title: 'Method 2',
                from: function () {},
            });
            done();
        });

        it('Title and Is', (done) => {
            T.register({
                title: 'Method 3',
                isTypeOf: function () {},
            });
            done();
        });

        it('Title, To, and Is', (done) => {
            T.register({
                title: 'Method 4',
                from: function () {},
                isTypeOf: function () {},
            });
            done();
        });

        it('Checking the list of methods', (done) => {
            const list = T.list();

            assert.deepEqual(list, [
                // Real methods
                { title: 'Boolean',   hasFrom: true,   hasIsTypeOf: true  },
                { title: 'String',    hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Date',      hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Function',  hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Array',     hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Number',    hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Object',    hasFrom: true,   hasIsTypeOf: true  },
                { title: 'Empty',     hasFrom: false,  hasIsTypeOf: true  },
                { title: 'Timestamp', hasFrom: true,   hasIsTypeOf: true  },
                { title: 'ValidDate', hasFrom: false,  hasIsTypeOf: true  },

                // Fake methods
                { title: 'Method 2', hasFrom: true,  hasIsTypeOf: false },
                { title: 'Method 3', hasFrom: false, hasIsTypeOf: true  },
                { title: 'Method 4', hasFrom: true,  hasIsTypeOf: true  },
            ]);

            done();
        });
    });
};