/**
 * Converts a test case into a string with a meaningful title
 * @param test
 */
module.exports = function (test) {

    if (test === undefined) {
        return 'undefined';
    }

    if (test === null) {
        return 'null';
    }

    switch(typeof test) {
        case 'function':
            return 'Function';
            break;
        case 'string':
            if (test.length < 1) {
                return 'Empty string';
            }
            else {
                return `"${test}"`;
            }
            break;
        case 'number':
            return test + '';
            break;
        case 'boolean':
            return test + '';
            break;
        case 'object':
            if (test.constructor === Array) {
                return `Array [${test.toString()}]`;
            }
            else if (test.getTime) {
                return `Date [${test.toDateString()}]`
            }
            else {
                return `Object {${Object.keys(test).toString()}`;
            }
            break;
    }
};