const assert = require('assert');

const T = require('../index');

describe('Testing Validation functions', () => {
    require('./suites/isArray')();
    require('./suites/isBoolean')();
    require('./suites/isDate')();
    require('./suites/isNumber')();
    require('./suites/isObject')();
    require('./suites/isString')();
    require('./suites/isFunction')();
    require('./suites/isEmpty')();
    require('./suites/isTimestamp')();
    require('./suites/isValidDate')();
});

describe('Testing Validation from constructor', () => {
    require('./suites/isArray')((value, mode) => {
        return T.Array.isTypeOf(value, mode);
    });
    require('./suites/isBoolean')((value, mode) => {
        return T.Boolean.isTypeOf(value, mode);
    });
    require('./suites/isDate')((value, mode) => {
        return T.Date.isTypeOf(value, mode);
    });
    require('./suites/isNumber')((value, mode) => {
        return T.Number.isTypeOf(value, mode);
    });
    require('./suites/isObject')((value, mode) => {
        return T.Object.isTypeOf(value, mode);
    });
    require('./suites/isString')((value, mode) => {
        return T.String.isTypeOf(value, mode);
    });
    require('./suites/isFunction')((value, mode) => {
        return T.Function.isTypeOf(value, mode);
    });
    require('./suites/isEmpty')((value, mode) => {
        return T.Empty.isTypeOf(value, mode);
    });
    require('./suites/isTimestamp')((value, mode) => {
        return T.Timestamp.isTypeOf(value, mode);
    });
    require('./suites/isValidDate')((value, mode) => {
        return T.ValidDate.isTypeOf(value, mode);
    });
});